<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques des aides financières n'ont pas pu être chargées."
    />
    <template v-else-if="financialHelpRequests">
      <h2 class="fr-h5">Aides financières</h2>
      <StatsList
        :stats="financialHelpRequestsCounts"
        :stats-percentage="false"
      />
      <p class="fr-text--bold stats-total-amount">
        Montant total des aides délivrées par la structure
        <span class="fr-h3">{{ financialHelpRequestsTotalAmount }}€</span>
      </p>
      <StatsList
        :stats="financialHelpRequestsAmountByType"
        :stats-percentage="false"
      />
    </template>
  </div>
</template>

<script setup>
  import { AlertType } from '~/utils/constants/alert'
  import { ACCEPTED_STATUS_VALUE } from '~/utils/constants/help-requests'
  import { errorResponseMessage } from '~~/utils/errorResponse'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: financialHelpRequests,
    pending,
    error
  } = useLazyAsyncData('financialHelpRequests', loadFinancialHelpRequests, {
    server: false
  })

  const financialHelpRequestsCount = computed(
    () => financialHelpRequests.value.length
  )

  const internalFinancialHelpRequests = computed(() =>
    financialHelpRequests.value.filter(
      request => !request.external_organisation
    )
  )

  const internalFinancialHelpRequestsCount = computed(
    () => internalFinancialHelpRequests.value.length
  )

  const externalFinancialHelpRequestsCount = computed(
    () =>
      financialHelpRequestsCount.value -
      internalFinancialHelpRequestsCount.value
  )

  const financialHelpRequestsCounts = computed(() => {
    const requestsCounts = {
      total: {
        key: 'total',
        label: 'Nombre de demandes',
        count: financialHelpRequestsCount.value
      },
      internal: {
        key: 'internal',
        label: 'Instruites en interne',
        count: internalFinancialHelpRequestsCount.value
      },
      external: {
        key: 'external',
        label: 'Instruites en externe',
        count: externalFinancialHelpRequestsCount.value
      }
    }
    const requestsCountsArray = Object.values(requestsCounts)
    requestsCountsArray.sort((a, b) => b.count - a.count)
    return requestsCountsArray
  })

  const financialHelpRequestsTotalAmount = computed(() =>
    internalFinancialHelpRequests.value
      .reduce(
        (total, request) =>
          request.status === ACCEPTED_STATUS_VALUE
            ? total + request.allocated_amount
            : total,
        0
      )
      .toFixed(2)
  )

  const financialHelpRequestsAmountByType = computed(() => {
    const requestsAmountByType = {}
    internalFinancialHelpRequests.value.forEach(request => {
      if (
        request.allocated_amount &&
        request.status === ACCEPTED_STATUS_VALUE
      ) {
        if (request.follow_up_type.id in requestsAmountByType) {
          requestsAmountByType[request.follow_up_type.id].count +=
            request.allocated_amount
        } else {
          requestsAmountByType[request.follow_up_type.id] = {
            key: request.follow_up_type.id,
            label: request.follow_up_type.name,
            color: '#E4794A',
            count: request.allocated_amount
          }
        }
      }
    })
    const requestsAmountByTypeArray = Object.values(requestsAmountByType)
    requestsAmountByTypeArray.forEach(request => {
      request.count = `${request.count}€`
    })
    requestsAmountByTypeArray.sort((a, b) => b.count - a.count)
    return requestsAmountByTypeArray
  })

  async function loadFinancialHelpRequests() {
    const res = await $getItems('help_requests', {
      fields: [
        'allocated_amount',
        'external_organisation',
        'follow_up_type.id',
        'follow_up_type.name',
        'status'
      ],
      filter: {
        ...props.filters,
        financial_support: { _eq: true }
      }
    })

    if (res.status === 200) {
      return res.data.data
    }
    throw new Error(errorResponseMessage(res))
  }
</script>

<style scoped>
  .stats-total-amount {
    display: flex;
    flex-direction: column;
  }

  .stats-total-amount span {
    color: var(--orange-terre-battue-main-645);
    margin-bottom: 0;
  }
</style>
